import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The cursor which aims the missiles and is controlled by the arrow keys
 * 
 * @author Xevinaly
 * @version v0.0.2
 */
public class Cursor extends FluidActor
{
    private Generator generator;
    
    /**
     * Constructor - sets the image
     */
    public Cursor(Generator passedgenerator) 
    {
        super("images/Cursor.txt", 15, 15);
        generator = passedgenerator;
    } 
    
    /**
     * Act - do whatever the Cursor wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if(Greenfoot.isKeyDown("up") && !generator.getNewLevel())
            setLocation(getX(), getY() - 5);
        else if(Greenfoot.isKeyDown("down") && !generator.getNewLevel())
            setLocation(getX(), getY() + 5);
        if(Greenfoot.isKeyDown("right") && !generator.getNewLevel())
            setLocation(getX() + 5, getY());
        else if(Greenfoot.isKeyDown("left") && !generator.getNewLevel())
            setLocation(getX() - 5, getY());
        if(getY() > 365)
            setLocation(getX(), 365);
    }    
}
