import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;

/**
 * An actor which uses a FluidImage
 * 
 * @author Xevinaly 
 * @version v0.0.2
 */
public class FluidActor extends Actor
{
    /**
     * Constructor - sets the image
     * 
     * @param imagefile the file to use with the FluidImage
     * @param height    the image height
     * @param width     the image width
     */
    public FluidActor(String imagefile, int height, int width) 
    {
        setImage(new FluidImage(imagefile, height, width));
    } 
    
    /**
     * getImage - an overidden method to get the image
     */
    public FluidImage getImage()
    {
        return (FluidImage)super.getImage();
    }
    
    /**
     * setImage - an overidden method to set the image
     * 
     * @param imagefile the file to use with the FluidImage
     * @param height    the image height
     * @param width     the image width
     */
    public void setImage(String imagefile, int height, int width)
    {
        super.setImage(new FluidImage(imagefile, height, width));
    }
    
    /**
     * getHitBox - returns the hitbox from the FluidImage
     * 
     * @return returns the hitbox of the used FluidImage
     */
    public ArrayList<int[]> getHitbox() 
    {
        return getImage().getHitbox();
    } 
}
