import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.io.*;
import java.util.StringTokenizer;
import java.awt.Color;
import java.util.ArrayList;

/**
 * Basically actual image class shit damn I hate this
 *
 * @author Xevinaly
 * @version v0.0.3
 */
public class FluidImage extends GreenfootImage
{
    private ArrayList<int[]> hitbox = new ArrayList<int[]>(), hitboxrange = new ArrayList<int[]>();
    private int colorscheme;

    /**
     * contructor - creates an image from the specified text file and with the specified dimensions
     *
     * @param file   the file to open
     * @param height the height of the image
     * @param width  the width of the image
     */
    public FluidImage(String file, int width, int height)
    {
        super(width, height);
        setColor(Color.BLACK);
        fill();
        hitbox.add(new int[]{width, height});
        try
        {
            FileReader input = new FileReader("Color_Scheme.txt");
            BufferedReader stream = new BufferedReader(input);
            colorscheme = Integer.parseInt(stream.readLine());
            stream.close();
            input.close();
        }
        catch(IOException e)
        {
            System.out.println("Error: Color_Scheme.txt not found");
            colorscheme = 0;
        }
        try
        {
            FileReader input = new FileReader(file);
            BufferedReader stream = new BufferedReader(input);
            String line = stream.readLine();
            int y = 0, index = 1;
            do {
                boolean start = true;
                int x = 0;
                StringTokenizer tokenizer = new StringTokenizer(line);
                while(tokenizer.hasMoreTokens())
                {
                    Color newcolor = getPixelColor(tokenizer.nextToken());
                    setColorAt(x, y, newcolor);
                    if(!(new Color(0, 0, 0, 0)).equals(newcolor))
                    {
                        hitbox.add(new int[]{x, y});
                        if(start)
                        {
                            hitboxrange.add(new int[]{y, index});
                            start = false;
                        }
                        index++;
                    }
                    x++;
                }
                line = stream.readLine();
                y++;
            } while(line != null);
            hitboxrange.add(new int[]{y, index});
            stream.close();
            input.close();
        }
        catch(IOException e)
        {
            System.out.println("Error: " + file + " not found");
        }
        catch(Exception e)
        {
            System.out.println("Error: something fucked up\n");
        }
    }

    /**
     * getPixelColor - sets pixel color based off of the key
     *
     * @param ID the string to match a color too
     */
    private Color getPixelColor(String ID)
    {
        if(ID.equals("-"))
            return new Color(0, 0, 0, 0);
        switch((Integer.parseInt(ID) + colorscheme)%8)
        {
            case 0: return Color.WHITE;
            case 1: return Color.RED;
            case 2: return Color.YELLOW;
            case 3: return Color.BLUE;
            case 4: return Color.ORANGE;
            case 5: return Color.PINK;
            case 6: return Color.CYAN;
            case 7: return Color.MAGENTA;
            case 8: return Color.GREEN;
            default: return new Color(0, 0, 0, 0);
        }
    }

    /**
     * getHitbox - returns the hitbox
     *
     * @return  the hitbox
     */
    public ArrayList<int[]> getHitbox()
    {
        return hitbox;
    }

    /**
     * compareHitboxs - compares two hitboxes and sees if they intersect
     *
     * @param otherhitbox the hitbox to compare with
     * @param otherx      the x-coordinate of the other object
     * @param othery      the y-coordinate of the other object
     * @param x           the x-coordinate of this object
     * @param y           the y-coordinate of this object
     * @return  whether this is an overlap
     */
    public boolean compareHitboxs(ArrayList<int[]> otherhitbox, int otherx, int othery, int x, int y)
    {
        for(int i = 1; i < otherhitbox.size(); i++)
            for(int j = 1; j < hitbox.size(); j++)
                if(otherhitbox.get(i)[0] - ((otherhitbox.get(0)[0] - 1) / 2) + otherx == hitbox.get(j)[0] - ((getWidth()) / 2) + x && otherhitbox.get(i)[1] - ((otherhitbox.get(0)[1] - 1) / 2) + othery == hitbox.get(j)[1] - ((getHeight()) / 2) + y)
                    return true;
        return false;
    }

    /**
     * hitboxOverlapRange - finds the two y values to look between
     *
     * @param otherhitboxminy the other hitbox's minimum y-coordinate value
     * @param otherhitboxmaxy the other hitbox's maximum y-coordinate value
     * @param thisy           the y-coordinate of this object
     */
    public int[] hitboxOverlapRange(int otherhitboxminy, int otherhitboxmaxy, int thisy)
    {
        int[] range = new int[]{hitboxrange.get(0)[1], hitboxrange.get(hitboxrange.size() - 1)[1]};
        for(int i = 2; i < hitboxrange.size(); i++)
        {
            if(hitboxrange.get(i)[0] + thisy == otherhitboxminy)
            {
               range[0] = hitboxrange.get(i - 1)[1];
               break;
            }
            else if(i + 1 < 9 && hitboxrange.get(i - 1)[0] + thisy < otherhitboxminy && hitboxrange.get(i + 1)[0] + thisy > otherhitboxminy)
            {
                range[0] = hitbox.get(i - 1)[1];
                break;
            }
        }
        for(int i = hitboxrange.size() - 2; i > 0; i--)
        {
            if(hitboxrange.get(i)[0] + thisy == otherhitboxmaxy)
            {
               range[1] = hitboxrange.get(i + 1)[1];
               break;
            }
            else if(i - 1 >= 0 && hitboxrange.get(i + 1)[0] + thisy < otherhitboxmaxy && hitboxrange.get(i - 1)[0] + thisy > otherhitboxmaxy)
            {
               range[1] = hitboxrange.get(i + 1)[1];
               break;
            }
        }
        return range;
    }

    /**
     * destroyHitboxOverlap - compares two hitboxes, sees if they intersect, removes the interacting pixels, and update the hitbox
     *
     * @param otherhitbox the hitbox to compare with
     * @param otherx      the x-coordinate of the other object
     * @param othery      the y-coordinate of the other object
     * @param x           the x-coordinate of this object
     * @param y           the y-coordinate of this object
     */
    public void destroyHitboxOverlap(ArrayList<int[]> otherhitbox, int otherx, int othery, int x, int y)
    {
        int[] range = hitboxOverlapRange(otherhitbox.get(1)[1] - ((otherhitbox.get(0)[1]) / 2) + othery, otherhitbox.get(otherhitbox.size() - 1)[1] - ((otherhitbox.get(0)[1]) / 2) + othery , y - (getHeight() / 2));

        for(int i = 1; i < otherhitbox.size(); i++)
            for(int j = range[0]; j < range[1]; j++)
                if(otherhitbox.get(i)[0] - ((otherhitbox.get(0)[0]) / 2) + otherx == hitbox.get(j)[0] - (getWidth() / 2) + x && otherhitbox.get(i)[1] - ((otherhitbox.get(0)[1]) / 2) + othery == hitbox.get(j)[1] - (getHeight() / 2) + y)
                    setColorAt(hitbox.get(j)[0], hitbox.get(j)[1], new Color(0, 0, 0, 0));
    }
    /**
     * findHitboxOverlap - compares two hitboxes, sees if they intersect, and color the intersecting pixels
     *
     * @param otherhitbox the hitbox to compare with
     * @param otherx      the x-coordinate of the other object
     * @param othery      the y-coordinate of the other object
     * @param x           the x-coordinate of this object
     * @param y           the y-coordinate of this object
     * @param newcolor    the color to switch pixels to
     */
    public void colorHitboxOverlap(ArrayList<int[]> otherhitbox, int otherx, int othery, int x, int y, int newcolor)
    {
        int[] range = hitboxOverlapRange(otherhitbox.get(1)[1] - ((otherhitbox.get(0)[1]) / 2) + othery, otherhitbox.get(otherhitbox.size() - 1)[1] - ((otherhitbox.get(0)[1]) / 2) + othery , y - (getHeight() / 2));

        for(int i = 1; i < otherhitbox.size(); i++)
            for(int j = range[0]; j < range[1]; j++)
                if(otherhitbox.get(i)[0] - ((otherhitbox.get(0)[0]) / 2) + otherx == hitbox.get(j)[0] - (getWidth() / 2) + x && otherhitbox.get(i)[1] - ((otherhitbox.get(0)[1]) / 2) + othery == hitbox.get(j)[1] - (getHeight() / 2) + y)
                    setColorAt(hitbox.get(j)[0], hitbox.get(j)[1], getPixelColor("" + newcolor));
    }
}
