import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Takes a string and creates a FluidImage out of it, only accepts letters and numbers
 * 
 * @author Xevinaly
 * @version v0.0.1
 */
public class FluidString extends Actor
{
    /**
     * Constructor - sets the image
     * 
     * @param imagefile  the string to display (only letters and numbers and spaces)
     */
    public FluidString(String displaystring) 
    {
        GreenfootImage img = new GreenfootImage(displaystring.length()*10, 15);
        img.setColor(Color.BLACK);
        img.fill();
        displaystring.toUpperCase();
        for(int i = 0; i < displaystring.length(); i++)
        {
            if(displaystring.charAt(i) != ' ')
            {
                FluidImage letter = new FluidImage(("images/" + displaystring.charAt(i) + ".txt"), 10, 15);
                for(int j = 0; j < 10; j++)
                    for(int l = 0; l < 15; l++)
                        img.setColorAt((i*10) + j, l, letter.getColorAt(j, l));
            }
        }
        setImage(img);
    }   
}
