import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.io.*;
import java.awt.Color;
import java.util.Random;

/**
 * Randomly generates the brick patterns, brick types and special bricks
 *
 * @author Xevinaly
 * @version v0.0.7
 */
public class Generator extends Actor
{
    private int extracities = 0, countdown = 0, level = 1, count = 0, barragenumber, splinterheight, missile = 0, missletnumber, missletchance, doublemissletchance, score = 0, multiplier = 1;
    private boolean start = true, newlevel = false, gameover = false, gameended = false;
    private int[][] coordinates = new int[][]{{92, 411}, {138, 414}, {187, 416}, {297, 409}, {358, 406}, {415, 409}, {45, 416}, {245, 416}, {477, 416}};
    private Cursor cursor = new Cursor(this);
    private City[] cities = new City[]{new City(), new City(), new City(), new City(), new City(), new City()};
    private Color contrailcolor;
    private FluidString alert;
    private Missile[] barrage;
    private FluidString multiplierimage = new FluidString("X1"), highscoreimage, scoreimage = new FluidString("" + score);
    private Random generator = new Random();
    private Bunker[] bunkers = new Bunker[]{new Bunker("A", cursor, this, setColor(level+4)), new Bunker("S", cursor, this, setColor(level+4)), new Bunker("D", cursor, this, setColor(level+4))};
    private FluidActor background1 = new FluidActor("images/Background1.txt", 100, 60),
                       background2 = new FluidActor("images/Background2.txt", 100, 60),
                       background3 = new FluidActor("images/Background3.txt", 100, 60),
                       background4 = new FluidActor("images/Background4.txt", 100, 60),
                       background5 = new FluidActor("images/Background5.txt", 100, 60);
    // Cutscene variables
    private int cutscenenumber = 0; // sets the part of the cutscene to watch
    private int cutscenecount = 0, cutscenecounts = 0; // sets the number of operations to do for each part of the cutscene
    private boolean cutsceneover = false;
    private int cutscenetimer = 5;
    private FluidString bonuspoints, bonusrockets, bonuscities;
    private int rocketbonus = 0, citiesbonus = 0;
    //Game Over variables
    private BlankActor blank = new  BlankActor();
    private String message = "In the end_ all is lost, there is no winner,";
    private FluidString typedmessage = new FluidString(" ");

    /**
     * constructor - sets the image
     */
    public Generator()
    {
        GreenfootImage img = new GreenfootImage(500, 450);
        img.setColor(new Color(0, 0, 0, 0));
        img.fill();
        setImage(img);
        barragenumber = 5;
        missletnumber = 2;
        missletchance = 10;
        doublemissletchance = 100;
        splinterheight = 150;
        contrailcolor = Color.GREEN;
    }

    /**
     * act - spawns the missiles, starts new levels
     */
    public void act()
    {
        if(start)
        {
            getWorld().addObject(background1, 50, 420);
            getWorld().addObject(background2, 150, 420);
            getWorld().addObject(background3, 250, 420);
            getWorld().addObject(background4, 350, 420);
            getWorld().addObject(background5, 450, 420);
            spawnCities();
            getWorld().addObject(bunkers[0], 45, 414);
            getWorld().addObject(bunkers[1], 245, 414);
            getWorld().addObject(bunkers[2], 477, 414);
            getWorld().addObject(cursor, 250, 225);
            getWorld().addObject(multiplierimage, 450, 7);
            getWorld().addObject(scoreimage, 50, 7);
            createBarrage();
            start = false;
        }
        else if(gameover)
        {
            cutscenetimer++;
            if(cutscenenumber == 0 && cutscenetimer >= 100)
            {
                GreenfootImage img = new GreenfootImage(500, 450);
                img.setColor(new Color(0, 0, 0, 0));
                img.fill();
                blank.setImage(img);
                getWorld().addObject(blank, 250, 225);
                cutscenenumber = 1;
            }
            else if(cutscenenumber == 1)
            {
                getWorld().removeObject(blank);
                cutscenecount++;
                GreenfootImage img = new GreenfootImage(500, 450);
                img.setColor(new Color(0, 0, 0, cutscenecount));
                img.fill();
                blank.setImage(img);
                getWorld().addObject(blank, 250, 225);
                if(cutscenecount >= 255)
                {
                    cutscenetimer = 0;
                    cutscenecount = 0;
                    cutscenenumber = 2;
                    getWorld().addObject(typedmessage, 250, 425);
                }
            }
            else if(cutscenenumber == 2 && cutscenetimer >= 5)
            {
                cutscenecount++;
                getWorld().removeObject(typedmessage);
                typedmessage = new FluidString(message.substring(0, cutscenecount));
                getWorld().addObject(typedmessage, 250, 225);
                cutscenetimer = 0;
                if(cutscenecount == 44)
                {
                    cutscenecount = 0;
                    cutscenenumber = 3;
                    getWorld().removeObject(scoreimage);
                    scoreimage = new FluidString("Final Score     " + score);
                    getWorld().addObject(scoreimage, 250, 250);
                }
            }
            else if(cutscenetimer >= 200)
            {
                gameended = true;
            }
        }
        else if(newlevel)
        {
            cutscenetimer++;
            if(cutscenenumber == 0 && cutscenetimer >= 5)
            {
                bonuspoints = new FluidString("Bonus Points");
                getWorld().addObject(bonuspoints, 250, 175);
                getWorld().removeObject(cursor);
                for(int i = 0; i < 6; i++)
                    if(!cities[i].getDestroyed())
                        cutscenecount++;
                cutscenenumber = 1;
            }
            else if(cutscenenumber == 1 && cutscenetimer >= 30)
            {
                for(int i = 0; i < 6; i++)
                {
                    if(!cities[i].getDestroyed() && !cities[i].getMoved())
                    {
                        cities[i].setLocation(200 + (33 * cutscenecounts), 200);
                        cities[i].setMoved();
                        citiesbonus += 100 * multiplier;
                        increaseScore(100);
                        cutscenecount--;
                        cutscenecounts++;
                        break;
                    }
                }
                try
                {
                    getWorld().removeObject(bonuscities);
                }catch(Exception e){}
                bonuscities = new FluidString("" + citiesbonus);
                getWorld().addObject(bonuscities, 150, 200);
                if(cutscenecount == 0)
                {
                    cutscenenumber = 2;
                    cutscenecounts = 0;
                    for(int i = 0; i < 3; i++)
                        cutscenecount += bunkers[i].remainingMissiles();
                }
                cutscenetimer = 0;
            }
            else if(cutscenenumber == 2 && cutscenetimer >= 10)
            {
                for(int i = 0; i < 3; i++)
                {
                    if(bunkers[i].hasMissiles())
                    {
                        int ydiff = 0;
                        if(cutscenecounts%2 == 0)
                            ydiff = 5;
                        bunkers[i].getNextMissile(188 + (5 * cutscenecounts), 225 - ydiff);
                        rocketbonus += 10 * multiplier;
                        increaseScore(10 * multiplier);
                        cutscenecount--;
                        cutscenecounts++;
                        break;
                    }
                }
                try
                {
                    getWorld().removeObject(bonusrockets);
                }catch(Exception e){}
                bonusrockets = new FluidString("" + rocketbonus);
                getWorld().addObject(bonusrockets, 150, 225);
                if(cutscenecount == 0)
                {
                    cutscenenumber = 3;
                    cutscenecounts = 0;
                }
                cutscenetimer = 0;
            }
            else if(cutscenetimer >= 150)
            {
                newlevel = false;
                cutsceneover = true;
                cutscenetimer = 5;
                cutscenenumber = 0;
                citiesbonus = 0;
                rocketbonus = 0;
                cutscenecount = 0;
            }
        }
        else if(cutsceneover)
        {
            clear();
            prepare();
            reset();
            countdown = 0;
            missile = 0;
            cutsceneover = false;
            start = true;
        }
        else
        {
            if(missile < barragenumber && count > 30)
            {
                getWorld().addObject(barrage[missile], 0, 0);
                missile++;
                count = 0;
            }
            if(missile >= barragenumber && getWorld().getObjects(Missile.class).size() == 0 && count > 0)
            {
                countdown++;
            }
            if(countdown == 200)
                newlevel = true;
            int citiesleft = 0;
            for(int i = 0; i < 6; i++)
                if(!cities[i].getDestroyed())
                    citiesleft++;
            if(citiesleft == 0 && extracities == 0)
                gameover = true;
            if(count == 30)
            {
                try
                {
                    getWorld().removeObject(alert);
                }catch(Exception e){}
            }
            count++;
        }
    }

    /**
     * createBarrage - creates the missiles by drawing a line on the image of the generator itself
     */
    private void createBarrage()
    {
        barrage = new Missile[barragenumber];
        for(int i = 0; i < barrage.length; i++)
        {
            int missiletype = generator.nextInt(missletchance);
            if(missiletype == 1)
                barrage[i] = new Missile(this, createContrail(generator.nextInt(480), 0, splinterheight, generator.nextInt(480)), splinterheight, contrailcolor, true, 1);
            else
            {
                int target = generator.nextInt(9);
                barrage[i] = new Missile(this, createContrail(generator.nextInt(480), 0, coordinates[target][1], coordinates[target][0]), 450, contrailcolor, true, 1);
            }
        }
    }

    /**
     * createContrail - creates the contrail path and erases it to be used in a new missile
     *
     * @param startx  the starting x coordinate
     * @param starty  the starting y coordinate
     * @param endy    the ending y coordinate
     * @param endx    the ending x coordinate
     * @return  the coordinates for the missile to follow
     */
    private int[][] createContrail(int startx, int starty, int endy, int endx)
    {
        getImage().setColor(Color.WHITE);
        getImage().drawLine(startx, starty, endx, endy);
        int count = 0;
        for(int i = Math.min(startx, endx); i <= Math.max(startx, endx); i++)
            for(int j = starty; j <= endy; j++)
                if(Color.WHITE.equals(getImage().getColorAt(i, j)))
                    count++;
        int[][] contrail = new int[count][2];
        count = 0;
        if(startx == Math.min(startx, endx))
        {
            for(int i = startx; i <= endx; i++)
            {
                for(int j = starty; j <= endy; j++)
                {
                    if(Color.WHITE.equals(getImage().getColorAt(i, j)))
                    {
                        contrail[count] = new int[]{i, j};
                        getImage().setColorAt(i, j, new Color(0, 0, 0, 0));
                        count++;
                    }
                }
            }
        }
        else
        {
            for(int i = startx; i >= endx; i--)
            {
                for(int j = starty; j <= endy; j++)
                {
                    if(Color.WHITE.equals(getImage().getColorAt(i, j)))
                    {
                        contrail[count] = new int[]{i, j};
                        getImage().setColorAt(i, j, new Color(0, 0, 0, 0));
                        count++;
                    }
                }
            }
        }
        return contrail;
    }

    /**
     * createFreindlyContrail - creates the contrail path and erases it to be used in a new missile for the player
     *
     * @param startx  the starting x coordinate
     * @param starty  the starting y coordinate
     * @param endy    the ending y coordinate
     * @param endx    the ending x coordinate
     * @return  the coordinates for the missile to follow
     */
    public int[][] createFriendlyContrail(int startx, int starty, int endy, int endx)
    {
        getImage().setColor(Color.WHITE);
        getImage().drawLine(startx, starty, endx, endy);
        int count = 0;
        for(int i = Math.min(startx, endx); i <= Math.max(startx, endx); i++)
            for(int j = starty; j >= endy; j--)
                if(Color.WHITE.equals(getImage().getColorAt(i, j)))
                    count++;
        int[][] contrail = new int[count][2];
        count = 0;
        if(startx == Math.min(startx, endx))
        {
            for(int i = startx; i <= endx; i++)
            {
                for(int j = starty; j >= endy; j--)
                {
                    if(Color.WHITE.equals(getImage().getColorAt(i, j)))
                    {
                        contrail[count] = new int[]{i, j};
                        getImage().setColorAt(i, j, new Color(0, 0, 0, 0));
                        count++;
                    }
                }
            }
        }
        else
        {
            for(int i = startx; i >= endx; i--)
            {
                for(int j = starty; j >= endy; j--)
                {
                    if(Color.WHITE.equals(getImage().getColorAt(i, j)))
                    {
                        contrail[count] = new int[]{i, j};
                        getImage().setColorAt(i, j, new Color(0, 0, 0, 0));
                        count++;
                    }
                }
            }
        }
        return contrail;
    }

    /**
     * spawnMisslets - spawns 5 misslets
     *
     * @param ylocation     the y location to begin the spawning
     * @param xlocation     the x location to begin the spawning
     * @param splinterable  whether this misslet can splinter
     */
    public void spawnMisslets(int ylocation, int xlocation, boolean splinterable)
    {
        for(int i = 0; i < missletnumber; i++)
        {
            int target = generator.nextInt(9);
            int missiletype = generator.nextInt(doublemissletchance);
            if(missiletype == 1 && splinterable)
                getWorld().addObject(new Missile(this, createContrail(xlocation, ylocation, coordinates[target][1], coordinates[target][0]), splinterheight + 100, contrailcolor, true, 1), xlocation, ylocation);
            else
                getWorld().addObject(new Missile(this, createContrail(xlocation, ylocation, coordinates[target][1], coordinates[target][0]), 450, contrailcolor, false, 1), xlocation, ylocation);
        }
    }

    /**
     * spawnCities - spawns the cities as long as they have not been hit
     */
    public void spawnCities()
    {
        for(int i = 0; i < 6; i++)
            if(!cities[i].getDestroyed())
                getWorld().addObject(cities[i], coordinates[i][0], coordinates[i][1]);
    }

    /**
     * increaseScore - increases the score by the given amount
     *
     * @param increase  the number of points earned
     */
    public void increaseScore(int increase)
    {
        int tempscore = score;
        score += increase * multiplier;
        getWorld().removeObject(scoreimage);
        scoreimage = new FluidString("" + score);
        getWorld().addObject(scoreimage, 50, 7);
        if(tempscore / 5000 < score / 5000)
        {
            extracities++;
            try
            {
                getWorld().removeObject(alert);
            }catch(Exception e){}
            alert = new FluidString("Extra City");
            getWorld().addObject(alert, 250, 7);
            count = 0;
        }
    }

    /**
     * getNewLevel - whether the game is transitioning between levels
     *
     * @return  if there is a transition between levels
     */
    public boolean getNewLevel()
    {
        return newlevel || gameover;
    }

    /**
     * getScore - returns the score
     *
     * @return  the current score
     */
    public int getScore()
    {
        return score;
    }

    /**
     * checkState - checks if the game is running
     *
     * @return  if the game is stopped yet
     */
    public int checkState()
    {
        if(gameended)
            return 0;
        return 1;
    }

    /**
     * resetColorScheme -  sets the color scheme back to 0
     */
    public void resetColorScheme()
    {
        try
        {
            FileWriter writer = new FileWriter("Color_Scheme.txt", false);
            writer.write("" + 0);
            writer.close();
        }
        catch(IOException e)
        {
            System.out.println("Error: Color_Scheme.txt not found");
        }
    }

    /**
     * setColor sets the new contrail color
     *
     * @param levels  the level to find the color for
     */
    private Color setColor(int levels)
    {
        switch((levels % 7) + 1)
        {
            case 1: return Color.GREEN;
            case 2: return Color.ORANGE;
            case 3: return Color.YELLOW;
            case 4: return Color.MAGENTA;
            case 5: return Color.CYAN;
            case 6: return Color.BLUE;
            case 7: return Color.PINK;
            case 8: return Color.RED;
            default: return new Color(0, 0, 0, 0);
        }
    }

    /**
     * clear - clears the bricks from the screen
     */
    public void clear()
    {
        getWorld().removeObject(background1);
        getWorld().removeObject(background2);
        getWorld().removeObject(background3);
        getWorld().removeObject(background4);
        getWorld().removeObject(background5);
        for(int i = 0; i < 6; i++)
            getWorld().removeObject(cities[i]);
        try
        {
            for(int i = 0; i < 3; i++)
                bunkers[i].selfDestruct();
        }catch(Exception e){}
        getWorld().removeObject(multiplierimage);
        getWorld().removeObject(scoreimage);
        getWorld().removeObject(bonusrockets);
        getWorld().removeObject(bonuscities);
        getWorld().removeObject(bonuspoints);
        getWorld().removeObject(cursor);
        try
        {
            getWorld().removeObject(alert);
        }catch(Exception e){}
        try
        {
            getWorld().removeObject(blank);
            getWorld().removeObject(typedmessage);
        }catch(Exception e){}
    }

    /**
     * prepare - prepares to reset the objects and start a new level
     */
    private void prepare()
    {
        level++;
        contrailcolor = setColor(level);
        if(level%3 == 0)
            barragenumber++;
        if(level%6 == 0)
            missletnumber++;
        if(level%6 == 0)
            missletchance--;
        if(level%2 == 0)
            doublemissletchance--;
        if(level%6 == 0)
            multiplier++;
        for(int i = 0; i < 6; i++)
        {
            if(cities[i].getDestroyed() && extracities != 0)
            {
                cities[i] = new City();
                extracities--;
            }
        }
        try
        {
            FileReader input = new FileReader("Color_Scheme.txt");
            BufferedReader stream = new BufferedReader(input);
            int currentcolorscheme = Integer.parseInt(stream.readLine());
            stream.close();
            input.close();
            currentcolorscheme++;
            FileWriter writer = new FileWriter("Color_Scheme.txt", false);
            writer.write("" + currentcolorscheme);
            writer.close();
        }
        catch(IOException e)
        {
            System.out.println("Error: Color_Scheme.txt not found");
        }
    }

    /**
     * reset - resets the objects used for the game so that they can update their color
     */
    private void reset()
    {
        for(int i = 0; i < 6; i++)
            if(!cities[i].getDestroyed())
                cities[i] = new City();
        cursor = new Cursor(this);
        bunkers = new Bunker[]{new Bunker("A", cursor, this, setColor(level+4)), new Bunker("S", cursor, this, setColor(level+4)), new Bunker("D", cursor, this, setColor(level+4))};
        background1 = new FluidActor("images/Background1.txt", 100, 60);
        background2 = new FluidActor("images/Background2.txt", 100, 60);
        background3 = new FluidActor("images/Background3.txt", 100, 60);
        background4 = new FluidActor("images/Background4.txt", 100, 60);
        background5 = new FluidActor("images/Background5.txt", 100, 60);
        multiplierimage = new FluidString("X" + multiplier);
        scoreimage = new FluidString("" + score);
    }
}
